<template>
  <div class="flex flex-col items-center text-center lg:items-end lg:text-right">
    <p class="m-0 text-white">
      Si vols estar al dia de les nostres activitats i dels avenços del projecte,
      subscriu-te!
    </p>
    <form class="mt-4" @submit.prevent="submit" novalidate autocomplete="off">
      <div class="max-w-sm flex items-center bg-gray-300 rounded-full shadow overflow-hidden">
        <input
          type="email"
          v-model.trim="form.email"
          class="appearance-none w-3/4 px-5 py-4 placeholder-gray-600 text-gray-700 focus:placeholder-gray-500 focus:outline-none"
          :class="{ 'text-red-500': !isEmailValid && dirty }"
          placeholder="adreça electrònica"
          aria-label="Adreça electrònica"
        />
        <button
          type="submit"
          class="appearance-none w-1/4 px-2 py-4 text-center text-sm font-medium focus:outline-none sm:px-5"
        >
          <span v-if="subscription.success" class="text-green-600">Fet!</span>
          <span v-else-if="subscription.error" class="text-red-500">Error!</span>
          <span
            v-else-if="subscription.pending"
            class="mx-auto fx-spin-circle"
            :style="{'--fx-spin-circle-color': theme.colors.pink['400'], '--fx-spin-circle-top-color': theme.colors.pink['700'] }"
          />
          <span v-else>Envia</span>
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import { required, isEmail } from '~/utils/validators';

const _doSubmit = async email => {
  const { api } = await import('~/api/repositories/netlify');
  return await api.subscribe(email);
};

export default {
  name: 'SubscriptionForm',
  inject: ['theme'],
  data() {
    return {
      dirty: false,
      form: {
        email: '',
      },
      subscription: {
        pending: false,
        success: false,
        error: false,
      },
    };
  },
  computed: {
    hasErrors() {
      return !this.isEmailValid;
    },
    isEmailValid() {
      const { email } = this.form;
      return required(email) && isEmail(email);
    },
  },
  methods: {
    async submit() {
      this.dirty = true;

      if (this.hasErrors) return;

      try {
        this.subscription.pending = true;

        await _doSubmit(this.form.email);
        this.record('success');

        this.resetForm();
      } catch (error) {
        this.record('error');
      } finally {
        this.subscription.pending = false;
      }
    },
    record(state) {
      this.subscription[state] = true;

      setTimeout(() => {
        this.subscription[state] = false;
      }, 10000); // 10s
    },
    resetForm() {
      this.form.email = '';
      this.dirty = false;
    },
  },
};
</script>
